/******************************
* This file is part of odeSD. *
******************************/ 

/* Standard header files. */ 
#include <stdlib.h> 
#include <string.h> 
#include <math.h> 

/* Library header files. */ 
#include <lapack.h> 
#include <blas.h>
#include <mex.h> 

/* Initial conditions. */ 
const int Elowitz2000_6states_Nstates = 6; 
const int Elowitz2000_6states_Nparams = 8;
mwSignedIndex mwElowitz2000_6states_Nstates = 6;
mwSignedIndex mwElowitz2000_6states_Nparams = 8;
double done = 1.0; 
const double Elowitz2000_6states_x0[6] = {0.0, 0.0, 0.0, 0.0, 2.e+01, 0.0};
const double Elowitz2000_6states_p[8] = {2.e+01, 2., 4.e+01, 2., 1.e+01, 0.5, 0.0005, 1.};
const char *Elowitz2000_6states_name = "Elowitz2000_6states";

/*****************************************
* Jacobian Right-hand side for ODE model *
*****************************************/

int Elowitz2000_6states_jac ( double time , const double *x , const double *f , const double *p , void *varargin , double *J , double *dJ , double *dfdp , double *d2fdtdp ) 
{ 
	/*******************************
	* STATE JACOBIAN EQUATIONS (J) *
	*******************************/ 
	
	if ( J != NULL || dJ != NULL || d2fdtdp != NULL ) 
	{ 
		memset( J , 0.0, sizeof(double) * Elowitz2000_6states_Nstates * Elowitz2000_6states_Nstates );
		
		J[0] = -6.931471805599453E-1/(p[4]*p[7]);
		J[4] = (p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7];
		J[7] = -6.931471805599453E-1/(p[4]*p[7]);
		J[11] = (p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7];
		J[14] = -6.931471805599453E-1/(p[4]*p[7]);
		J[15] = (p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7];
		J[18] = (p[0]*6.931471805599453E-1)/(p[3]*p[7]);
		J[21] = -6.931471805599453E-1/(p[3]*p[7]);
		J[25] = (p[0]*6.931471805599453E-1)/(p[3]*p[7]);
		J[28] = -6.931471805599453E-1/(p[3]*p[7]);
		J[32] = (p[0]*6.931471805599453E-1)/(p[3]*p[7]);
		J[35] = -6.931471805599453E-1/(p[3]*p[7]);

	} 

	/*********************************************
	* JACOBIAN OF 2nd DERIVATIVE EQUATIONS (Jgx) *
	*********************************************/

	if ( dJ != NULL )
    { 
		memset( dJ , 0.0, sizeof(double) * Elowitz2000_6states_Nstates * Elowitz2000_6states_Nstates ); 
        
		dJ[4] += f[0]*(p[1]*p[1])*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),3.0)*pow(x[0]/p[7],p[1]*2.0-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0-f[0]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*(p[1]-1.0)*pow(x[0]/p[7],p[1]-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0;
		dJ[11] += f[1]*(p[1]*p[1])*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),3.0)*pow(x[1]/p[7],p[1]*2.0-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0-f[1]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*(p[1]-1.0)*pow(x[1]/p[7],p[1]-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0;
		dJ[15] += f[2]*(p[1]*p[1])*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),3.0)*pow(x[2]/p[7],p[1]*2.0-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0-f[2]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*(p[1]-1.0)*pow(x[2]/p[7],p[1]-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0;


		dgemm("N", "N", &mwElowitz2000_6states_Nstates, &mwElowitz2000_6states_Nstates, &mwElowitz2000_6states_Nstates, &done, J, &mwElowitz2000_6states_Nstates, J, &mwElowitz2000_6states_Nstates, &done, dJ, &mwElowitz2000_6states_Nstates);  
	 } 


    /************************************** 
    * PARAMETER JACOBIAN EQUATIONS (dfdp) * 
    **************************************/

    if ( dfdp != NULL || d2fdtdp != NULL )
    { 
        memset( dfdp , 0.0, sizeof(double) * Elowitz2000_6states_Nstates * Elowitz2000_6states_Nparams ); 
		dfdp[0] = (x[3]*6.931471805599453E-1)/(p[3]*p[7]);
		dfdp[1] = (x[4]*6.931471805599453E-1)/(p[3]*p[7]);
		dfdp[2] = (x[5]*6.931471805599453E-1)/(p[3]*p[7]);
		dfdp[9] = pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*(pow(p[2],p[1])*log(p[2])+log(x[2]/p[7])*pow(x[2]/p[7],p[1]))*(p[5]*6.0E1-p[6]*6.0E1)*-1.0+(pow(p[2],p[1])*log(p[2])*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[2]/p[7],p[1]));
		dfdp[10] = pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*(pow(p[2],p[1])*log(p[2])+log(x[0]/p[7])*pow(x[0]/p[7],p[1]))*(p[5]*6.0E1-p[6]*6.0E1)*-1.0+(pow(p[2],p[1])*log(p[2])*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[0]/p[7],p[1]));
		dfdp[11] = pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*(pow(p[2],p[1])*log(p[2])+log(x[1]/p[7])*pow(x[1]/p[7],p[1]))*(p[5]*6.0E1-p[6]*6.0E1)*-1.0+(pow(p[2],p[1])*log(p[2])*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[1]/p[7],p[1]));
		dfdp[15] = (p[1]*pow(p[2],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[2]/p[7],p[1]))-p[1]*pow(p[2],p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0;
		dfdp[16] = (p[1]*pow(p[2],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[0]/p[7],p[1]))-p[1]*pow(p[2],p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0;
		dfdp[17] = (p[1]*pow(p[2],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[1]/p[7],p[1]))-p[1]*pow(p[2],p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0;
		dfdp[18] = (p[0]*1.0/(p[3]*p[3])*x[3]*-6.931471805599453E-1)/p[7];
		dfdp[19] = (p[0]*1.0/(p[3]*p[3])*x[4]*-6.931471805599453E-1)/p[7];
		dfdp[20] = (p[0]*1.0/(p[3]*p[3])*x[5]*-6.931471805599453E-1)/p[7];
		dfdp[21] = (1.0/(p[3]*p[3])*x[3]*6.931471805599453E-1)/p[7];
		dfdp[22] = (1.0/(p[3]*p[3])*x[4]*6.931471805599453E-1)/p[7];
		dfdp[23] = (1.0/(p[3]*p[3])*x[5]*6.931471805599453E-1)/p[7];
		dfdp[24] = (1.0/(p[4]*p[4])*x[0]*6.931471805599453E-1)/p[7];
		dfdp[25] = (1.0/(p[4]*p[4])*x[1]*6.931471805599453E-1)/p[7];
		dfdp[26] = (1.0/(p[4]*p[4])*x[2]*6.931471805599453E-1)/p[7];
		dfdp[33] = (pow(p[2],p[1])*6.0E1)/(pow(p[2],p[1])+pow(x[2]/p[7],p[1]));
		dfdp[34] = (pow(p[2],p[1])*6.0E1)/(pow(p[2],p[1])+pow(x[0]/p[7],p[1]));
		dfdp[35] = (pow(p[2],p[1])*6.0E1)/(pow(p[2],p[1])+pow(x[1]/p[7],p[1]));
		dfdp[39] = (pow(p[2],p[1])*-6.0E1)/(pow(p[2],p[1])+pow(x[2]/p[7],p[1]))+6.0E1;
		dfdp[40] = (pow(p[2],p[1])*-6.0E1)/(pow(p[2],p[1])+pow(x[0]/p[7],p[1]))+6.0E1;
		dfdp[41] = (pow(p[2],p[1])*-6.0E1)/(pow(p[2],p[1])+pow(x[1]/p[7],p[1]))+6.0E1;
		dfdp[42] = (1.0/(p[7]*p[7])*x[0]*6.931471805599453E-1)/p[4]-(p[0]*1.0/(p[7]*p[7])*x[3]*6.931471805599453E-1)/p[3];
		dfdp[43] = (1.0/(p[7]*p[7])*x[1]*6.931471805599453E-1)/p[4]-(p[0]*1.0/(p[7]*p[7])*x[4]*6.931471805599453E-1)/p[3];
		dfdp[44] = (1.0/(p[7]*p[7])*x[2]*6.931471805599453E-1)/p[4]-(p[0]*1.0/(p[7]*p[7])*x[5]*6.931471805599453E-1)/p[3];
		dfdp[45] = (1.0/(p[7]*p[7])*x[3]*6.931471805599453E-1)/p[3]+p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*x[2]*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1);
		dfdp[46] = (1.0/(p[7]*p[7])*x[4]*6.931471805599453E-1)/p[3]+p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*x[0]*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1);
		dfdp[47] = (1.0/(p[7]*p[7])*x[5]*6.931471805599453E-1)/p[3]+p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*x[1]*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1);

    } 

    /****************************************************
    * 2nd derivative PARAMETER JACOBIAN EQUATIONS (Jgp) *
    ****************************************************/ 

    if ( d2fdtdp != NULL )
    { 
        memset( d2fdtdp , 0.0, sizeof(double) * Elowitz2000_6states_Nstates * Elowitz2000_6states_Nparams ); 

		d2fdtdp[0] += (f[3]*6.931471805599453E-1)/(p[3]*p[7]);
		d2fdtdp[1] += (f[4]*6.931471805599453E-1)/(p[3]*p[7]);
		d2fdtdp[2] += (f[5]*6.931471805599453E-1)/(p[3]*p[7]);
		d2fdtdp[9] += (f[2]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7]+(f[2]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),3.0)*pow(x[2]/p[7],p[1]-1.0)*(pow(p[2],p[1])*log(p[2])+log(x[2]/p[7])*pow(x[2]/p[7],p[1]))*(p[5]*6.0E1-p[6]*6.0E1)*2.0)/p[7]-(f[2]*p[1]*pow(p[2],p[1])*log(p[2])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7]-(f[2]*p[1]*pow(p[2],p[1])*log(x[2]/p[7])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7];
		d2fdtdp[10] += (f[0]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7]+(f[0]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),3.0)*pow(x[0]/p[7],p[1]-1.0)*(pow(p[2],p[1])*log(p[2])+log(x[0]/p[7])*pow(x[0]/p[7],p[1]))*(p[5]*6.0E1-p[6]*6.0E1)*2.0)/p[7]-(f[0]*p[1]*pow(p[2],p[1])*log(p[2])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7]-(f[0]*p[1]*pow(p[2],p[1])*log(x[0]/p[7])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7];
		d2fdtdp[11] += (f[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7]+(f[1]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),3.0)*pow(x[1]/p[7],p[1]-1.0)*(pow(p[2],p[1])*log(p[2])+log(x[1]/p[7])*pow(x[1]/p[7],p[1]))*(p[5]*6.0E1-p[6]*6.0E1)*2.0)/p[7]-(f[1]*p[1]*pow(p[2],p[1])*log(p[2])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7]-(f[1]*p[1]*pow(p[2],p[1])*log(x[1]/p[7])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7];
		d2fdtdp[15] += (f[2]*(p[1]*p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7]+(f[2]*(p[1]*p[1])*pow(p[2],p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),3.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0)/p[7];
		d2fdtdp[16] += (f[0]*(p[1]*p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7]+(f[0]*(p[1]*p[1])*pow(p[2],p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),3.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0)/p[7];
		d2fdtdp[17] += (f[1]*(p[1]*p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*-1.0)/p[7]+(f[1]*(p[1]*p[1])*pow(p[2],p[1])*pow(p[2],p[1]-1.0)*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),3.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0)/p[7];
		d2fdtdp[18] += (f[3]*p[0]*1.0/(p[3]*p[3])*-6.931471805599453E-1)/p[7];
		d2fdtdp[19] += (f[4]*p[0]*1.0/(p[3]*p[3])*-6.931471805599453E-1)/p[7];
		d2fdtdp[20] += (f[5]*p[0]*1.0/(p[3]*p[3])*-6.931471805599453E-1)/p[7];
		d2fdtdp[21] += (f[3]*1.0/(p[3]*p[3])*6.931471805599453E-1)/p[7];
		d2fdtdp[22] += (f[4]*1.0/(p[3]*p[3])*6.931471805599453E-1)/p[7];
		d2fdtdp[23] += (f[5]*1.0/(p[3]*p[3])*6.931471805599453E-1)/p[7];
		d2fdtdp[24] += (f[0]*1.0/(p[4]*p[4])*6.931471805599453E-1)/p[7];
		d2fdtdp[25] += (f[1]*1.0/(p[4]*p[4])*6.931471805599453E-1)/p[7];
		d2fdtdp[26] += (f[2]*1.0/(p[4]*p[4])*6.931471805599453E-1)/p[7];
		d2fdtdp[33] += (f[2]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*-6.0E1)/p[7];
		d2fdtdp[34] += (f[0]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*-6.0E1)/p[7];
		d2fdtdp[35] += (f[1]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*-6.0E1)/p[7];
		d2fdtdp[39] += (f[2]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*6.0E1)/p[7];
		d2fdtdp[40] += (f[0]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*6.0E1)/p[7];
		d2fdtdp[41] += (f[1]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*6.0E1)/p[7];
		d2fdtdp[42] += (f[0]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[4]-(f[3]*p[0]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[3];
		d2fdtdp[43] += (f[1]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[4]-(f[4]*p[0]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[3];
		d2fdtdp[44] += (f[2]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[4]-(f[5]*p[0]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[3];
		d2fdtdp[45] += (f[3]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[3]+f[2]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)-f[2]*(p[1]*p[1])*pow(p[2],p[1])*1.0/(p[7]*p[7]*p[7])*x[2]*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),3.0)*pow(x[2]/p[7],p[1]*2.0-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0+f[2]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7]*p[7])*x[2]*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*(p[1]-1.0)*pow(x[2]/p[7],p[1]-2.0)*(p[5]*6.0E1-p[6]*6.0E1);
		d2fdtdp[46] += (f[4]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[3]+f[0]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)-f[0]*(p[1]*p[1])*pow(p[2],p[1])*1.0/(p[7]*p[7]*p[7])*x[0]*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),3.0)*pow(x[0]/p[7],p[1]*2.0-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0+f[0]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7]*p[7])*x[0]*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*(p[1]-1.0)*pow(x[0]/p[7],p[1]-2.0)*(p[5]*6.0E1-p[6]*6.0E1);
		d2fdtdp[47] += (f[5]*1.0/(p[7]*p[7])*6.931471805599453E-1)/p[3]+f[1]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)-f[1]*(p[1]*p[1])*pow(p[2],p[1])*1.0/(p[7]*p[7]*p[7])*x[1]*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),3.0)*pow(x[1]/p[7],p[1]*2.0-2.0)*(p[5]*6.0E1-p[6]*6.0E1)*2.0+f[1]*p[1]*pow(p[2],p[1])*1.0/(p[7]*p[7]*p[7])*x[1]*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*(p[1]-1.0)*pow(x[1]/p[7],p[1]-2.0)*(p[5]*6.0E1-p[6]*6.0E1);


        dgemm("N", "N", &mwElowitz2000_6states_Nstates, &mwElowitz2000_6states_Nparams, &mwElowitz2000_6states_Nstates, &done, J, &mwElowitz2000_6states_Nstates, dfdp, &mwElowitz2000_6states_Nstates, &done, d2fdtdp, &mwElowitz2000_6states_Nstates);  
    } 


 /* All is well that ends well... */ 
 return 0; 

} 


/********************************
* Right-hand side for ODE model *
********************************/

int Elowitz2000_6states_f ( double time , const double *x , const double *p , void *varargin , double *f , double *dfdt , double *J , double *dJ , double *dfdp , double *d2fdtdp )
{ 
	int res = 0;

	/*******************************
	* 1st DERIVATIVE EQUATIONS (f) *
	*******************************/

		f[0] = (x[0]*-6.931471805599453E-1)/(p[4]*p[7])+(p[0]*x[3]*6.931471805599453E-1)/(p[3]*p[7]);
		f[1] = (x[1]*-6.931471805599453E-1)/(p[4]*p[7])+(p[0]*x[4]*6.931471805599453E-1)/(p[3]*p[7]);
		f[2] = (x[2]*-6.931471805599453E-1)/(p[4]*p[7])+(p[0]*x[5]*6.931471805599453E-1)/(p[3]*p[7]);
		f[3] = p[6]*6.0E1-(x[3]*6.931471805599453E-1)/(p[3]*p[7])+(pow(p[2],p[1])*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[2]/p[7],p[1]));
		f[4] = p[6]*6.0E1-(x[4]*6.931471805599453E-1)/(p[3]*p[7])+(pow(p[2],p[1])*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[0]/p[7],p[1]));
		f[5] = p[6]*6.0E1-(x[5]*6.931471805599453E-1)/(p[3]*p[7])+(pow(p[2],p[1])*(p[5]*6.0E1-p[6]*6.0E1))/(pow(p[2],p[1])+pow(x[1]/p[7],p[1]));


	/***************************************
	* 2nd DERIVATIVE EQUATIONS (Jfx*f = g) *  
	****************************************/

	if ( dfdt != NULL ) 
	{ 
		dfdt[0] = (f[0]*-6.931471805599453E-1)/(p[4]*p[7])+(f[3]*p[0]*6.931471805599453E-1)/(p[3]*p[7]);
		dfdt[1] = (f[1]*-6.931471805599453E-1)/(p[4]*p[7])+(f[4]*p[0]*6.931471805599453E-1)/(p[3]*p[7]);
		dfdt[2] = (f[2]*-6.931471805599453E-1)/(p[4]*p[7])+(f[5]*p[0]*6.931471805599453E-1)/(p[3]*p[7]);
		dfdt[3] = (f[3]*-6.931471805599453E-1)/(p[3]*p[7])-(f[2]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[2]/p[7],p[1]),2.0)*pow(x[2]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7];
		dfdt[4] = (f[4]*-6.931471805599453E-1)/(p[3]*p[7])-(f[0]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[0]/p[7],p[1]),2.0)*pow(x[0]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7];
		dfdt[5] = (f[5]*-6.931471805599453E-1)/(p[3]*p[7])-(f[1]*p[1]*pow(p[2],p[1])*1.0/pow(pow(p[2],p[1])+pow(x[1]/p[7],p[1]),2.0)*pow(x[1]/p[7],p[1]-1.0)*(p[5]*6.0E1-p[6]*6.0E1)*1.0)/p[7];

	} 

	/* Jacobians and stuff. */ 
	if ( ( res = Elowitz2000_6states_jac(time , x , f , p , varargin , J , dJ , dfdp , d2fdtdp ) ) < 0 ) 
	return res; 

	/* All is well... */ 
	return 0; 
 } 

